/*******************************************************************************
 *
 * File Name: LDparser.h
 * Author: Richard Baxter
 * Project: Generic Ldraw Construct Functions
 * Project Version: 1z3b 19-Sept-09 (COMPILE_OLC only release)
 *
 *******************************************************************************/


#ifndef HEADER_LD_PARSER
#define HEADER_LD_PARSER

#include "LDreferenceClass.h"



#ifdef LINUX
	#define DEFAULT_PARTS_DIRECTORY_FULL_PATH "/usr/share/local/LDRAW/PARTS/"
	#define DEFAULT_PRIMITIVES_DIRECTORY_FULL_PATH "/usr/share/local/LDRAW/P/"
#else
	#define DEFAULT_PARTS_DIRECTORY_FULL_PATH "C:/Program Files/LDraw/PARTS/"
	#define DEFAULT_PRIMITIVES_DIRECTORY_FULL_PATH "C:/Program Files/LDraw/P/"
#endif

#define LD_PARSER_ALLOW_WHITE_SPACE (true)



#ifdef USE_LRRC
void fillInParserExternVariables();
#endif

//generic parser
bool parseFile(char * parseFileName, Reference * initialReference, Reference * parentReference, bool recurseIntoPartsDir);
	#ifdef USE_LRRC
	void updateUnitDetailsWithCombatDetails(char* subPartFileName, ModelDetails * u);
	void updateUnitDetailsWithBuildingDetails(char* subPartFileName, ModelDetails * u);
	void updateUnitDetailsWithTypeDetails(char* subPartFileName, ModelDetails * u);
	void updateUnitDetailsWithTerrainDefenceDetails(char* subPartFileName, ModelDetails * u);
	#endif

double calcModXPosBasedUponRotate(vec * childRelativePosition, mat * parentReferenceDeformationMatrix);
double calcModYPosBasedUponRotate(vec * childRelativePosition, mat * parentReferenceDeformationMatrix);
double calcModZPosBasedUponRotate(vec * childRelativePosition, mat * parentReferenceDeformationMatrix);

bool removeWhiteSpaceFromString(char * s);


#endif
