/*******************************************************************************
 *
 * File Name: OLC.h
 * Author: Richard Baxter
 * Project: Optional Line Creator
 * Project Version: 1c1b 19-Sept-09 (part file white space/syntax requirement relaxation, Added UI option to create edge line instead of optional line where the angle between the two intersecting polygons is less than x degrees)
 * First Major Release: 1b9b 12-June-07
 * Comments: NB - no recursive parsing.
 *
 *******************************************************************************/

#include "LDreferenceClass.h"
//#include "SHAREDvars.h"

#define OPTIONAL_LINE_DATA_HEADER "0 \n0 Optional Line Data (generated using OLC.exe):\n0 \n"

//#define OLD_COLINEAR_OLS_CHECK

int main(int argc,char **argv);

bool createPartWithOptionalLines(char * partFileOriginalName, char * partFileModifiedName, bool createEdges, float edgeThreshold);

bool partOptionalLinesFileOutput(char * partFileModifiedName, char * partFileOriginalName, Reference * initialReferenceInPart, bool createEdges, float edgeThreshold);

/***************************** PART 1 ***********************************************/
void createReferenceListOfOptionalLines(Reference * initialReferenceInPart, Reference * initialReferenceInOptionalLineData, bool createEdges, float edgeThreshold);
	Reference * addOptionalLineReferencesForQuad(Reference * quadReference, Reference * currentReferenceInOptionalLineData, Reference * initialReferenceInPart, Reference * initialReferenceInOptionalLineData, bool * result, bool createEdges, float edgeThreshold);
	Reference * addOptionalLineReferencesForTri(Reference * triReference, Reference * currentReferenceInOptionalLineData, Reference * initialReferenceInPart, Reference * initialReferenceInOptionalLineData, bool * result, bool createEdges, float edgeThreshold);
		Reference * findCorrespondingPrimRefEdgeAndAddOptionalLine(Reference * polyReference, Reference * polyReferenceRotated, Reference * currentReferenceInOptionalLineData, Reference * initialReferenceInPart, Reference * initialReferenceInOptionalLineData, bool * result, bool createEdges, float edgeThreshold);
			Reference * fillEdgeOrOptionalLine(Reference * polyReferenceRotated, Reference * currentReferenceInPartRotated, Reference * currentReferenceInOptionalLineData, Reference * initialReferenceInOptionalLineData, bool * result, bool createEdges, float edgeThreshold);
				Reference * fillOptionalLine(Reference * polyReferenceRotated, Reference * currentReferenceInPartRotated, Reference * currentReferenceInOptionalLineData, Reference * initialReferenceInOptionalLineData, bool * result);
				Reference * fillEdgeLine(vec * polyReferenceVertexA, vec * polyReferenceVertexB, Reference * currentReferenceInOptionalLineData, Reference * initialReferenceInOptionalLineData, bool * result);
				double calculateAngleBetweenNormalsOfPolys(Reference * polyReferenceRotated, Reference * currentReferenceInPartRotated);
					bool search1DRefListFindAnyLikeLineRef(Reference * referenceToFind, Reference * initialReferenceInList);
						bool compareAnyLikeLineReferences(Reference * reference1, Reference * reference2);
					//these should be shifted elsewhere
					void search1DRefListRemoveRef(Reference * referenceToFindAndRemove, Reference * initialReferenceInList, bool * result);
					void search1DRefListRemoveAnyLikeOptionalLineRef(Reference * referenceToFindAndRemove, Reference * initialReferenceInList, bool * result);
bool compareAnyLikeOptionalLineReferences(Reference * reference1, Reference * reference2);
bool compareAnyLikeEdgeLineReferences(Reference * reference1, Reference * reference2);
bool search1DRefListFindAnyLikeEdgeLineRef(Reference * referenceToFind, Reference * initialReferenceInList);