/*******************************************************************************
 *
 * File Name: SHAREDvars.cpp
 * Author: Richard Baxter
 * Project: Generic Construct Functions
 * Project Version: 1z3b 19-Sept-09 (COMPILE_OLC only release)
 *
 *******************************************************************************/
 
#include "SHAREDvars.h"

#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <iostream>
#include <fstream>
#include <time.h>
#include <math.h>
using namespace std;

void copyColours(colour * colToModify, colour * colToCopy)
{
	colToModify->r = colToCopy->r;
	colToModify->g = colToCopy->g;
	colToModify->b = colToCopy->b;
}


bool compareDoublesArbitraryError(double a, double b, double error)
{
	bool result;
	if((a < (b+error)) && (a > (b-error)))
	{
		result = true;
	}
	else
	{
		result = false;
	}

	return result;
}

bool compareDoubles(double a, double b)
{
	bool result;
	if((a < (b+DOUBLE_MIN_PRECISION)) && (a > (b-DOUBLE_MIN_PRECISION)))
	{
		result = true;
	}
	else
	{
		result = false;
	}

	return result;
}


//generic functions

int maxInt(int a, int b)
{
	if(a > b)
	{
		return a;
	}
	else
	{
		return b;
	}
}

int minInt(int a, int b)
{
	if(a < b)
	{
		return a;
	}
	else
	{
		return b;
	}
}

double minDouble(double a, double b)
{
	if(a < b)
	{
		return a;
	}
	else
	{
		return b;
	}
}
double maxDouble(double a, double b)
{
	if(a > b)
	{
		return a;
	}
	else
	{
		return b;
	}
}

double absDouble(double val)
{
	if(val < 0.0)
	{
		return (-val);
	}
	else
	{
		return val;
	}
}




int exists_argument(int argc,char **argv,char *keystr)
{
  int i;

  for (i=1;i<argc;i++) if (strstr(argv[i],keystr)) return 1;
  return 0;
}

float get_float_argument(int argc,char **argv,char *keystr)
{
  int i;
  float result=0.0;

  for (i=1;i<argc;i++){
    if (strstr(argv[i],keystr)){
      result=atof(argv[i+1]);
      break;
    }
  }
  if (i == argc){ 
    fprintf(stderr,"Error: get_float_argument(%s)\n",keystr);
    return (float) -999999999;
  }
  else return result;
}

char *get_char_argument(int argc,char **argv,char *keystr)
{
  int i;
  char *result;

  result=(char *) malloc(256);
  result[0]=0;

  for (i=1;i<argc;i++){
    if (strstr(argv[i],keystr)){
      sprintf(result,"%s",argv[i+1]);
      break;
    }
  }
  if (i == argc) fprintf(stderr,"Error: get_char_argument(%s)\n",keystr);

  return result;
}

