/*******************************************************************************
 *
 * File Name: SHAREDvars.h
 * Author: Richard Baxter
 * Project: Generic Construct Functions
 * Project Version: 1z3b 19-Sept-09 (COMPILE_OLC only release)
 *
 *******************************************************************************/
 
#ifndef HEADER_SHARED_VARS
#define HEADER_SHARED_VARS

#include "SHAREDglobalDefs.h"

#define TRUE (1)
#define FALSE (0)

#define REALLY_FAR_AWAY (99999999999.9)
#define REALLY_LARGE_DOUBLE (1000000.0)
#define REALLY_SMALL_DOUBLE (-1000000.0)

/* common definitions */
typedef struct { unsigned char r, g, b; } colour;
typedef struct { double x, y, z; } vec;
typedef struct { vec a; vec b; vec c; } mat;

#ifdef COMPILE_OLC
	#define DOUBLE_MIN_PRECISION 0.005
#else
	#define DOUBLE_MIN_PRECISION 0.00001
#endif

bool compareDoubles(double a, double b);
bool compareDoublesArbitraryError(double a, double b, double error);

int maxInt(int a, int b);	//should be turned into a macro instead
int minInt(int a, int b);	//should be turned into a macro instead

double minDouble(double a, double b);	//should be turned into a macro instead
double maxDouble(double a, double b);	//should be turned into a macro instead

double absDouble(double val);

int exists_argument(int argc,char **argv,char *keystr);
float get_float_argument(int argc,char **argv,char *keystr);
char *get_char_argument(int argc,char **argv,char *keystr);

void copyColours(colour * colToModify, colour * colToCopy);

#endif
